#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include "buffer.h"
#include "env.h"
#include "error.h"
#include "stralloc.h"
#include "strerr.h"
#include "random.h"

#define FATAL "qdated-makekey: fatal: "

void die_nomem() { strerr_die2x(1,FATAL,"out of memory."); }

stralloc key = {0};

void keyadd(unsigned short u)
{
  char ch;
  ch = u; if (!stralloc_append(&key,&ch)) die_nomem(); u >>= 8;
  ch = u; if (!stralloc_append(&key,&ch)) die_nomem();
}

stralloc fn = {0};
char *home;
char seed[128];
char bspace[128];
int fd, i;
buffer b;

int main()
{
  home = env_get("HOME");
  if (!home)
    strerr_die2x(1,FATAL,"can't figure out where HOME is.");
  if (!stralloc_copys(&fn,home)) die_nomem();
  if (!stralloc_cats(&fn,"/.qdated-key")) die_nomem();
  if (!stralloc_0(&fn)) die_nomem();

  if ((fd = open(fn.s,O_WRONLY | O_EXCL | O_CREAT,0600)) == -1)
    strerr_die2x(1,FATAL,error_str(errno));

  random_init(seed);
  for (i=0;i < 64;++i)
    keyadd((unsigned short)random(65536));

  buffer_init(&b,buffer_unixwrite,fd,bspace,sizeof bspace);
  buffer_putflush(&b,key.s,key.len);

  close(fd);

  return(0);
}
