#include <time.h>
#include "fmt.h"
#include "env.h"
#include "stralloc.h"
#include "buffer.h"
#include "strerr.h"
#include "openreadclose.h"
#include "scan.h"
#include "cookie.h"
#include "qdated.h"

#define FATAL "qdated-now: fatal: "

void die_nomem() { strerr_die2x(1,FATAL,"out of memory."); }

char str_now[FMT_ULONG];
char hash[COOKIE];
char *home;
unsigned long futuredate = 0;
stralloc fn = {0};
stralloc ext = {0};
stralloc key = {0};

int main(int argc,char **argv)
{
  long now = time((time_t *) 0);

  if (argv++ && *argv)
    scan_ulong(*argv,&futuredate);
  if (futuredate < 1000) futuredate *= 86400;
  now = now + futuredate - BASETIME;

  home = env_get("HOME");
  if (!home)
    strerr_die2x(1,FATAL,"can't figure out where HOME is.");

  if (!stralloc_copys(&fn,home)) die_nomem();
  if (!stralloc_cats(&fn,"/.qdated-key")) die_nomem();
  if (!stralloc_0(&fn)) die_nomem();

  if (!openreadclose(fn.s,&key,32))
    strerr_die2x(1,FATAL,"can't open key file. Please run qdated-makekey.");

  str_now[fmt_ulong(str_now,now)] = 0;

  cookie(hash,key.s,key.len,str_now);

  if (!stralloc_copys(&ext,str_now)) die_nomem();
  if (!stralloc_cats(&ext,".")) die_nomem();
  if (!stralloc_catb(&ext,hash,COOKIE)) die_nomem();

  buffer_put(buffer_1,ext.s,ext.len);
  buffer_flush(buffer_1);
 
  return(0);
}
